com.tibbo.aggregate.common.action

## Interface ActionDefinition

- All Superinterfaces:
    java.lang.Comparable, EntityDefinition
  All Known Implementing Classes:
    BasicActionDefinition, EditTemplateActionDefinition, ServerActionDefinition

      public interface ActionDefinition
      extends java.lang.Comparable, EntityDefinition

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `KeyStroke` | `getAccelerator()` Returns key stroke used to initiate the action in any UI.
    `java.util.List<ResourceMask>` | `getDropSources()` Returns the drop source context masks.
    `GroupIdentifier` | `getExecutionGroup()` Some category of actions may be applied to groups of objects.
    `java.util.concurrent.locks.ReentrantLock` | `getExecutionLock()` Returns the execution lock
    `Permissions` | `getPermissions()` Returns permissions required to execute action.
    `Action` | `instantiate()` Creates and return an instance of the action
    `boolean` | `isConcurrent()` If false, parallel execution of several action instances is not allowed
    `boolean` | `isDefault()` Returns true if action is a default action in context.
    `boolean` | `isEnabled()` Returns true if action execution is allowed.
    `boolean` | `isHeadless()` Returns true if action supports non-interactive execution.
    `boolean` | `isHidden()` Returns true if action is hidden.
    `void` | `setDefault(boolean b)` Sets default flag for the action.
    `void` | `setEnabled(boolean enabled)` Enables/disables action.

    - ### Methods inherited from interface java.lang.Comparable

      `compareTo`

    - ### Methods inherited from interface com.tibbo.aggregate.common.context.EntityDefinition

      `getDescription, getEntityType, getGroup, getHelp, getIconId, getIndex, getName, getOwner, toDetailedString`

- - ### Method Detail

    - #### isEnabled

          boolean isEnabled()

      Returns true if action execution is allowed.

    - #### setEnabled

          void setEnabled(boolean enabled)

      Enables/disables action.

    - #### isDefault

          boolean isDefault()

      Returns true if action is a default action in context.

    - #### setDefault

          void setDefault(boolean b)

      Sets default flag for the action.

    - #### isHeadless

          boolean isHeadless()

      Returns true if action supports non-interactive execution.

    - #### isHidden

          boolean isHidden()

      Returns true if action is hidden.

    - #### getAccelerator

          KeyStroke getAccelerator()

      Returns key stroke used to initiate the action in any UI.

    - #### getDropSources

          java.util.List<ResourceMask> getDropSources()

      Returns the drop source context masks.

    - #### getPermissions

          Permissions getPermissions()

      Returns permissions required to execute action.

    - #### getExecutionGroup

          GroupIdentifier getExecutionGroup()

      Some category of actions may be applied to groups of objects. To make system know what actions to group the definition has an execution group. If action can't be grouped, execution group should be null.

    - #### instantiate

          Action instantiate()

      Creates and return an instance of the action

    - #### isConcurrent

          boolean isConcurrent()

      If false, parallel execution of several action instances is not allowed

    - #### getExecutionLock

          java.util.concurrent.locks.ReentrantLock getExecutionLock()

      Returns the execution lock